
function love.load()
  shader = love.graphics.newShader(
  [[
    #ifdef VERTEX
    vec4 position( mat4 transform_projection, vec4 vertex_position )
    {
        return transform_projection * vertex_position; // default vertex shader
    }
    #endif
    #ifdef PIXEL
    extern vec4 palette_colors[2]; // size of color palette (2 colors)
    
    vec4 effect( vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords ) {
        return palette_colors[int(floor(VaryingTexCoord.x))]; // abuse u (texture x) coordinate as color index
    }
    #endif
  ]] )
  
  mesh = love.graphics.newMesh( {
    { -1, -1, 0 }, { 1, -1, 0 }, { 0, 1.4, 0 }, -- triangle #1 uses first color (0)
    { 3, 0, 1 }, { 5, -3, 1 }, { 2, 2, 1 }      -- triangle #2 uses second color (1)
  }, nil, "triangles" )
end

function love.draw()
  love.graphics.setShader( shader )
  love.graphics.translate( 150, 300 )
  love.graphics.push()
    love.graphics.scale( 50 )
    shader:send( "palette_colors", { 255, 0, 0, 255 }, { 0, 255, 0, 255 } ) -- red and green
    love.graphics.draw( mesh )
  love.graphics.pop()
  love.graphics.translate( 250, 0 )
  love.graphics.scale( 50 )
  shader:send( "palette_colors", { 255, 255, 255, 255 }, { 0, 0, 255, 255 } ) -- white and blue
  love.graphics.draw( mesh )
end
